import { Component, Input } from '@angular/core';
import { ActionButton, MenuDropdownItem } from '../models/common.model';
import { HeaderBreadcrumb, HeaderNavRoute, HeaderTag } from './header.model';

@Component({
  selector: 'x-header',
  templateUrl: './header.component.html',
  styleUrls: ['./header.component.scss'],
})
export class HeaderComponent {
  @Input() title: string = '';
  @Input() subTitle?: string = '';
  @Input() tags?: HeaderTag[];
  @Input() primaryButton?: ActionButton;
  @Input() secondaryButtons?: ActionButton[];
  @Input() ellipsisDropdownItems?: MenuDropdownItem[];
  @Input() breadcrumbItems?: HeaderBreadcrumb[];
  @Input() navRoutes?: HeaderNavRoute[];
}
