export enum ResponseStatus {
  Success = 'SUCCESS',
  Failed = 'FAILED',
}

export interface HttpResponse {
  data: any;
  responseStatus: ResponseStatus;
  statusCode: number;
  errorCode?: { message: string };
}

interface ActionItem {
  text: string;
  nzIconName?: string;
  disabled?: boolean;
  action: (...args: any[]) => void;
}
export interface ActionButton extends ActionItem {}
export interface MenuDropdownItem extends ActionItem {}
