import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

import { UmbrellaLibraryComponent } from './umbrella-library.component';

import { UmbrellaDataTableModule } from './public-modules/data-table/umbrella-table.module';
import { UmbrellaHeaderModule } from './public-modules/header/umbrella-header.module';
import { UmbrellaFooterModule } from './public-modules/footer/umbrella-footer.module';

import { NzAnchorModule } from 'ng-zorro-antd/anchor';
import { NzBreadCrumbModule } from 'ng-zorro-antd/breadcrumb';
import { NzButtonModule } from 'ng-zorro-antd/button';
import { NzCardModule } from 'ng-zorro-antd/card';
import { NzCascaderModule } from 'ng-zorro-antd/cascader';
import { NzCollapseModule } from 'ng-zorro-antd/collapse';
import { NzDividerModule } from 'ng-zorro-antd/divider';
import { NzDrawerModule } from 'ng-zorro-antd/drawer';
import { NzFormModule } from 'ng-zorro-antd/form';
import { NzGridModule } from 'ng-zorro-antd/grid';
import { NzIconModule, NzIconService } from 'ng-zorro-antd/icon';
import { NzInputModule } from 'ng-zorro-antd/input';
import { NzInputNumberModule } from 'ng-zorro-antd/input-number';
import { NzMessageModule } from 'ng-zorro-antd/message';
import { NzModalModule } from 'ng-zorro-antd/modal';
import { NzPageHeaderModule } from 'ng-zorro-antd/page-header';
import { NzPaginationModule } from 'ng-zorro-antd/pagination';
import { NzRadioModule } from 'ng-zorro-antd/radio';
import { NzResultModule } from 'ng-zorro-antd/result';
import { NzSelectModule } from 'ng-zorro-antd/select';
import { NzSpaceModule } from 'ng-zorro-antd/space';
import { NzSpinModule } from 'ng-zorro-antd/spin';
import { NzSwitchModule } from 'ng-zorro-antd/switch';
import { NzTableModule } from 'ng-zorro-antd/table';
import { NzTabsModule } from 'ng-zorro-antd/tabs';
import { NzTagModule } from 'ng-zorro-antd/tag';
import { NzToolTipModule } from 'ng-zorro-antd/tooltip';
import { NzTypographyModule } from 'ng-zorro-antd/typography';

import {
  EditOutline,
  PlusOutline,
  DeleteOutline,
  WarningOutline,
} from '@ant-design/icons-angular/icons';
import { ReactiveFormsModule } from '@angular/forms';

import { IconDefinition } from '@ant-design/icons-angular';

/* Ant icon definitions */
const icons: IconDefinition[] = [EditOutline, PlusOutline, DeleteOutline, WarningOutline];

@NgModule({
  declarations: [UmbrellaLibraryComponent],
  imports: [
    /* Angular Modules */
    CommonModule,
    ReactiveFormsModule,

    /* Umbrella Modules */
    UmbrellaHeaderModule,
    UmbrellaFooterModule,
    UmbrellaDataTableModule,

    /* Ant Modules */
    NzAnchorModule,
    NzBreadCrumbModule,
    NzButtonModule,
    NzCardModule,
    NzCascaderModule,
    NzCollapseModule,
    NzDividerModule,
    NzDrawerModule,
    NzFormModule,
    NzGridModule,
    NzIconModule,
    NzIconModule.forChild(icons),
    NzInputModule,
    NzInputNumberModule,
    NzMessageModule,
    NzModalModule,
    NzPageHeaderModule,
    NzPaginationModule,
    NzRadioModule,
    NzResultModule,
    NzSelectModule,
    NzSpaceModule,
    NzSpinModule,
    NzSwitchModule,
    NzTableModule,
    NzTabsModule,
    NzTagModule,
    NzToolTipModule,
    NzTypographyModule,
  ],
  exports: [
    /* Angular Modules */
    CommonModule,
    ReactiveFormsModule,

    /* Umbrella Modules */
    UmbrellaHeaderModule,
    UmbrellaFooterModule,
    UmbrellaDataTableModule,

    /* Ant Modules */
    NzAnchorModule,
    NzBreadCrumbModule,
    NzButtonModule,
    NzCardModule,
    NzCascaderModule,
    NzCollapseModule,
    NzDividerModule,
    NzDrawerModule,
    NzFormModule,
    NzGridModule,
    NzIconModule,
    NzInputModule,
    NzInputNumberModule,
    NzMessageModule,
    NzModalModule,
    NzPageHeaderModule,
    NzPaginationModule,
    NzRadioModule,
    NzResultModule,
    NzSelectModule,
    NzSpaceModule,
    NzSpinModule,
    NzSwitchModule,
    NzTableModule,
    NzTabsModule,
    NzTagModule,
    NzToolTipModule,
    NzTypographyModule,
  ],
})
export class UmbrellaLibraryModule {
  /* This is required for Ant icons to work under umbrella assets structure
     https://ng.ant.design/components/icon/en#static-loading-and-dynamic-loading */
  //  constructor(private _iconService: NzIconService) {
  //   this._iconService.changeAssetsSource('fleet-manager');
  // }
}
